/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web._base.frame");

(function(){

// OSLC IFrame communication frame protocols
var PROTOCOL_WINDOWNAME = '#oslc-windowName-1.0';
var PROTOCOL_POSTMSG = '#oslc-postMessage-1.0';

var POSTMSG_PREFIX = 'oslc-response:';

dojo.mixin(com.ibm.rational.cm.web,
{
	getLocationHash: function() {
		var result = window.location.hash;
		if (result)
			return result;
		result = window.document.URL;
		var index = result.indexOf('#');
		if (index > 0)
			return result.substr(index);
		return "";
	},

	/*
	 * Sends a response to an outside observer using C/ALM IFrame communication frameProtocols.
	 * See: https://jazz.net/wiki/bin/view/Main/CalmFrameCommunicationProtocols
	 */
	sendFrameResponse: function (/*string*/ response) {
		var frameProtocol = this.getLocationHash();
		
		//console.debug("sendFrameResponse: " + response);
		//console.debug("Frame Protocol: " + frameProtocol);
		
		// If there was no frameProtocol specified, we have nothing to do.
		if (frameProtocol == "") {
			return;
		}
		
		// If the frameProtocol is unsupported, throw an error.
		if (frameProtocol != PROTOCOL_POSTMSG
				&& frameProtocol != PROTOCOL_WINDOWNAME)
			throw new Error('Unsupported frame communication frameProtocol: ' + frameProtocol);
		
		if (frameProtocol == PROTOCOL_WINDOWNAME) {
			var returnURL = window.name;
			window.name = response;
	        window.location = returnURL;
		} else {
			(window.parent || window).postMessage(POSTMSG_PREFIX + response, "*");
		}
	}
});

})();
