/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.build.web.ui.internal.EngineColumn");

dojo.require("com.ibm.team.build.web.ui.internal.BuildQueryColumn");

dojo.require("jazz.util.html");

dojo.require("dojo.date");
dojo.require("dojo.date.locale");
dojo.require("dojo.date.stamp");
dojo.require("dojo.string");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.build.web.ui.internal", "BuildMessages");

(function() {

var messages = dojo.i18n.getLocalization("com.ibm.team.build.web.ui.internal", "BuildMessages");

dojo.declare("com.ibm.team.build.web.ui.internal.EngineStateColumn",
 com.ibm.team.build.web.ui.internal.BuildQueryIconColumn,
{     
	getClassName: function(result){
		var statusClass = "normalEngine";
		if (result.buildEngine.active && result.monitoringThresholdExceeded) {
            statusClass =  "warningEngine";
        }
		return statusClass;
	}
});

dojo.declare("com.ibm.team.build.web.ui.internal.EngineIdColumn",
 com.ibm.team.build.web.ui.internal.BuildQueryColumn,
{     
	getInnerHtml: function(result){
		return result.buildEngine.id ? jazz.util.html.escape(result.buildEngine.id) : "";
	}
});

dojo.declare("com.ibm.team.build.web.ui.internal.EngineStatusColumn",
 com.ibm.team.build.web.ui.internal.BuildQueryColumn,
{     
	getInnerHtml: function(result){
		if (result.buildEngine.active && result.monitoringThresholdExceeded) {
            return messages.engineWarning;
        }

        if (!result.buildEngine.active) {
            return messages.engineInactive;
        } else if (result.inProgressBuilds && result.inProgressBuilds.length > 0) {
            return messages.engineBusy;
        } else {
            return messages.engineIdle;
        }
	}
});

dojo.declare("com.ibm.team.build.web.ui.internal.EngineLastContactTimeColumn",
 com.ibm.team.build.web.ui.internal.BuildQueryColumn,
{     
	getInnerHtml: function(result){
		var lastContactTime = "";
		if(result.lastContactTime){
			lastContactTime = dojo.date.stamp.fromISOString(result.lastContactTime);
			lastContactTime = dojo.date.locale.format(lastContactTime, {formatLength: "medium" })
		}
		return lastContactTime;
	}
});
	
})();
