/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.IncludeArchived");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() { // module container

/**
 * Widget to display admin options.
 */
dojo.declare("com.ibm.team.reports.web.ui.internal.IncludeArchived",	[dijit._Widget, dijit._Templated], {
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/IncludeArchived.html"),

		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
			this._controller = args.controller;
		},

		postCreate: function() {
			com.ibm.team.reports.web.ui.internal.IncludeArchived.superclass.postCreate.apply(this);
			this.connect(this._archivedCheckbox, "onclick", this._checkboxHandler);
		},
		
		_checkboxHandler: function() {
			this._controller.setIncludeArchived(this._archivedCheckbox.checked);
			this._controller.reload();
		}
	}
);

})();