/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.calm.RequirementsCollectionLoader");//$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.calm.CALMDocument");//$NON-NLS-1$

(function() {
var CALMDocument= com.ibm.team.apt.web.ui.internal.calm.CALMDocument;

dojo.declare("com.ibm.team.apt.web.ui.internal.calm.RequirementsCollectionLoader", null, {//$NON-NLS-1$

	constructor: function(resultCallback, resourceURLs) {
		if (this.declaredClass === "com.ibm.team.apt.web.ui.internal.calm.RequirementsCollectionLoader")//$NON-NLS-1$
			this.$ctor.apply(this, arguments);
	},

	_resultCallback: null,

	_result: null,

	_collectionsToLoad: null,

	_requirementsToLoad: null,

	$ctor: function(resultCallback, resourceURLs) {
		this._resultCallback= resultCallback;
		this._collectionsToLoad= resourceURLs;
		this._requirementsToLoad= [];
		this._result= [];
		if (this._collectionsToLoad.length === 0){
			resultCallback.callback(this);
		};
		this._loadCollection();
	},

	_loadCollection: function() {
		var resourceURL= this._collectionsToLoad.pop();
		var requestHeaders= {};
		requestHeaders["Accept"]= "application/x-oslc-rdm-requirement-collection+xml";//$NON-NLS-1$//$NON-NLS-2$
		var deferred= new dojo.Deferred();
		deferred.addErrback(this.createErrorHandler());
		deferred.addCallback(dojo.hitch(this, function(resourceDoc) {
			this._collectionResourceLoaded(resourceDoc);
			return resourceDoc;
		}));
		CALMDocument.load(resourceURL, deferred, requestHeaders);
	},

	_collectionResourceLoaded: function(resourceDoc) {
		var nodes= resourceDoc.getNodes("rdf:RDF/oslc_rm:RequirementCollection/rdf:li");//$NON-NLS-1$
		for (var i= 0; i < nodes.length; i++){
			var requirementResource= resourceDoc.getAttributeTextForNode(nodes[i], "@rdf:resource");//$NON-NLS-1$
			if (requirementResource != null && requirementResource.length > 0 && !this.containsRequirement(requirementResource)){
				this._requirementsToLoad.push(requirementResource);
			};
		};
		if (this._collectionsToLoad.length > 0){
			this._loadCollection();
		}
		else 
			if (this._requirementsToLoad.length > 0){
				this._loadRequirements();
			}
			else {
				this._resultCallback.callback(this);
			};;
	},

	_loadRequirements: function() {
		var requirementResource= this._requirementsToLoad.pop();
		var requestHeaders= {};
		requestHeaders["Accept"]= "application/x-oslc-rdm-requirement+xml";//$NON-NLS-1$//$NON-NLS-2$
		var deferred= new dojo.Deferred();
		deferred.addErrback(this.createErrorHandler());
		deferred.addCallback(dojo.hitch(this, function(resourceDoc) {
			this._requirementResourceLoaded(resourceDoc);
			return resourceDoc;
		}));
		CALMDocument.load(requirementResource, deferred, requestHeaders);
	},

	_requirementResourceLoaded: function(resourceDoc) {
		var resourceURL= resourceDoc.getAttributeText("rdf:RDF/oslc_rm:Requirement/@rdf:about");//$NON-NLS-1$
		var title= resourceDoc.getNodeText("rdf:RDF/oslc_rm:Requirement/dc:title");//$NON-NLS-1$
		var description= resourceDoc.getNodeText("rdf:RDF/oslc_rm:Requirement/dc:description");//$NON-NLS-1$
		if (resourceURL != null && title != null){
			var info= {};
			info.resourceURL= resourceURL;
			info.title= title;
			info.description= description != null ? description : "";//$NON-NLS-1$
			this._result.push(info);
		};
		if (this._requirementsToLoad.length > 0){
			this._loadRequirements();
		}
		else {
			this._resultCallback.callback(this);
		};
	},

	getLoadedEntries: function() {
		return this._result;
	},

	createErrorHandler: function() {
		return dojo.hitch(this, function(error) {
			this._resultCallback.errback(error);
			return error;
		});
	},

	containsRequirement: function(requirementResource) {
		for (var i= 0; i < this._requirementsToLoad.length; i++){
			if (this._requirementsToLoad[i] === requirementResource){
				return true;
			};
		};
		return false;
	}
});

})();
