/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.calm.WorkItemsFromRequirementsDialog");//$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory");//$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemAttributes");//$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.InlineWorkItemContent");//$NON-NLS-1$
dojo.require("dijit._Templated");//$NON-NLS-1$
dojo.require("dijit._Widget");//$NON-NLS-1$
dojo.require("jazz.ui.Dialog");//$NON-NLS-1$

(function() {
var WorkItemProxyFactory= com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory;
var WorkItemAttributes= com.ibm.team.workitem.web.client.internal.WorkItemAttributes;
var InlineWorkItemContent= com.ibm.team.workitem.web.ui2.internal.widget.InlineWorkItemContent;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var Dialog= jazz.ui.Dialog;

dojo.declare("com.ibm.team.apt.web.ui.internal.calm.WorkItemsFromRequirementsDialog", [ _Widget, _Templated], {//$NON-NLS-1$

	constructor: function(args) {
		if (this.declaredClass === "com.ibm.team.apt.web.ui.internal.calm.WorkItemsFromRequirementsDialog")//$NON-NLS-1$
			this.$ctor.apply(this, arguments);
	},

	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/calm/templates/WorkItemsFromRequirementsDialog.html"),//$NON-NLS-1$//$NON-NLS-2$

	_messages: dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"),//$NON-NLS-1$//$NON-NLS-2$

	_contentArea: null,

	_buttonSection: null,

	_applyAllButton: null,

	_nextButton: null,

	_cancelButton: null,

	_progressLabel: null,

	_createdItems: null,

	_isCreateAll: null,

	_projectAreaItemId: null,

	_workItemType: null,

	_initialAttributes: null,

	_onClose: null,

	_requirementInfos: null,

	_currentRequirementIndex: null,

	_currentInlineWorkItemContent: null,

	_dialog: null,

	$ctor: function(args) {
		this._onClose= args.onClose;
		this._projectAreaItemId= args.projectAreaItemId;
		this._requirementInfos= args.requirementInfos;
		this._workItemType= args.workItemType;
		this._initialAttributes= args.initialAttributes;
		this._currentRequirementIndex= 0;
		this._createdItems= [];
		this._isCreateAll= false;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []);//$NON-NLS-1$
		this._updateButtons(false);
		this._updateProgressLabel();
		this._createWorkItemForNextRequirement(this._initialAttributes);
	},

	show: function() {
		var args= {};
		args.contentNode= this.domNode;
		args.primaryTitle= this._messages.ITEMS_FROM_REQ_CREATE_DIALOG_TITLE;
		args.width= "59em";//$NON-NLS-1$
		args.onClose= dojo.hitch(this, function() {
			this._onDialogClosed();
		});
		this._dialog= new Dialog(args);
	},

	hide: function() {
		if (this._dialog != null){
			this._dialog.close(null);
		};
	},

	_showLoadingNode: function(isLoading) {
		if (this._contentArea.firstChild != null){
			this._contentArea.removeChild(this._contentArea.firstChild);
		};
		var loadingDiv= window.document.createElement("div");//$NON-NLS-1$
		loadingDiv.className= "loading";//$NON-NLS-1$
		loadingDiv.appendChild(window.document.createTextNode(this._messages.ITEMS_FROM_REQ_LOADING));
		this._contentArea.appendChild(loadingDiv);
	},

	_getCurrentRequirement: function() {
		return this._requirementInfos[this._currentRequirementIndex];
	},

	_createWorkItemForNextRequirement: function(initialAttributes) {
		if (this._currentRequirementIndex >= this._requirementInfos.length){
			return ;
		};
		if (this._contentArea.firstChild != null){
			this._contentArea.removeChild(this._contentArea.firstChild);
		};
		this._showLoadingNode(true);
		var deferred= new dojo.Deferred();
		deferred.addCallback(dojo.hitch(this, function(workingCopy) {
			this._onWorkItemProxyReadyToShow(workingCopy);
			return workingCopy;
		}));
		deferred.addErrback(dojo.hitch(this, function(error) {
			this._handleError(dojo.string.substitute(this._messages.ITEMS_FROM_REQ_ERROR_INITIALIZING, [error]), error);
			return error;
		}));
		this._createWorkItemProxy(initialAttributes, deferred);
	},

	_createWorkItemProxy: function(initialAttributes, deferred) {
		var proxyArgs= {};
		proxyArgs.createIfNeeded= true;
		var workingCopy= WorkItemProxyFactory.getWorkItemProxy(proxyArgs);
		workingCopy.incrementUseCount();
		var initArgs= {};
		initArgs.fetchEditorPresentation= false;
		initArgs.fetchInlinePresentation= false;
		initArgs.type= this._workItemType;
		initArgs.onSuccess= dojo.hitch(this, function() {
			this._onWorkItemProxyInitialized(workingCopy, initialAttributes, deferred);
		});
		initArgs.onError= dojo.hitch(this, function() {
			deferred.errback({});
		});
		workingCopy.initialize(initArgs);
	},

	_onWorkItemProxyInitialized: function(workingCopy, initialAttributes, deferred) {
		var requirement= this._getCurrentRequirement();
		if (initialAttributes != null){
			for (var i= 0; i < initialAttributes.length; i++){
				var current= initialAttributes[i];
				workingCopy.setValue(current);
			};
		};
		this._setWorkingCopyContentValue(workingCopy, WorkItemAttributes.SUMMARY, requirement.title);
		this._setWorkingCopyContentValue(workingCopy, WorkItemAttributes.DESCRIPTION, requirement.description);
		this._setWorkingCopyURLLinkValue(workingCopy, "com.ibm.team.workitem.linktype.implementsRequirement", requirement.resourceURL, requirement.title);//$NON-NLS-1$
		deferred.callback(workingCopy);
	},

	_onWorkItemProxyReadyToShow: function(workingCopy) {
		this._currentInlineWorkItemContent= this._createInlineWorkItemEditor(workingCopy);
		if (this._contentArea.firstChild != null){
			this._contentArea.removeChild(this._contentArea.firstChild);
		};
		this._contentArea.appendChild(this._currentInlineWorkItemContent.domNode);
		this._updateButtons(true);
	},

	_setWorkingCopyContentValue: function(workingCopy, attributeId, newValue) {
		var args= {};
		args.caller= this;
		args.path= ["attributes", attributeId, "content"];//$NON-NLS-1$//$NON-NLS-2$
		args.savedAttributePath= ["attributes", attributeId, "content"];//$NON-NLS-1$//$NON-NLS-2$
		args.attributeId= attributeId;
		args.value= newValue;
		workingCopy.setValue(args);
	},

	_setWorkingCopyURLLinkValue: function(workingCopy, linkTypeName, url, comment) {
		var linkTypeValue= {};
		linkTypeValue["url"]= url;//$NON-NLS-1$
		linkTypeValue["comment"]= comment;//$NON-NLS-1$
		var setValArgs= {};
		setValArgs.path= ["linkTypes", linkTypeName];//$NON-NLS-1$
		setValArgs.value= [linkTypeValue];
		workingCopy.setValue(setValArgs);
	},

	_createInlineWorkItemEditor: function(workingCopy) {
		var contentParams= {};
		contentParams.workingCopy= workingCopy;
		contentParams.parentWidget= this;
		contentParams.onClose= dojo.hitch(this, function(info, changedAttributes) {
			this._onEditorFinished(info, changedAttributes);
		});
		contentParams.okEnabled= dojo.hitch(this, function(isEnabled) {
			this._onOkEnablementChange(isEnabled);
		});
		return new InlineWorkItemContent(contentParams);
	},

	onApplyAllButton: function(event) {
		this._isCreateAll= true;
		this._updateButtons(false);
		this._currentInlineWorkItemContent.handleOk(event);
	},

	onNextButton: function(event) {
		this._isCreateAll= false;
		this._updateButtons(false);
		this._currentInlineWorkItemContent.handleOk(event);
	},

	onCancelButton: function(event) {
		this._isCreateAll= false;
		this._updateButtons(false);
		this._cancelButton.disabled= "disabled";//$NON-NLS-1$
		this._currentInlineWorkItemContent.handleCancel(event);
	},

	_onEditorFinished: function(info, changedAttributes) {
		if (info === null){
			this.hide();
			return ;
		};
		this._createdItems.push(info);
		this._currentInlineWorkItemContent= null;
		this._currentRequirementIndex++;
		this._updateProgressLabel();
		if (this._currentRequirementIndex < this._requirementInfos.length){
			if (this._isCreateAll){
				this._createRemainingWorkItems(changedAttributes);
			}
			else {
				this._createWorkItemForNextRequirement(changedAttributes);
				return ;
			};
		}
		else {
			this.hide();
			return ;
		};
	},

	_createRemainingWorkItems: function(attributes) {
		if (this._currentRequirementIndex < this._requirementInfos.length){
			var deferred= new dojo.Deferred();
			deferred.addCallback(dojo.hitch(this, function(workingCopy) {
				this._onRemainingWorkItemConfigured(workingCopy, attributes);
				return workingCopy;
			}));
			deferred.addErrback(dojo.hitch(this, function(error) {
				this._handleError(dojo.string.substitute(this._messages.ITEMS_FROM_REQ_ERROR_INITIALIZING, [error]), error);
				return error;
			}));
			this._createWorkItemProxy(attributes, deferred);
		}
		else {
			this.hide();
		};
	},

	_onRemainingWorkItemConfigured: function(workingCopy, attributes) {
		var saveArgs= {};
		saveArgs.instigator= this;
		saveArgs.operationMsg= "";//$NON-NLS-1$
		saveArgs.onSuccess= dojo.hitch(this, function(resultParameters) {
			this._onRemainingWorkItemSaved(workingCopy, attributes);
		});
		saveArgs.onError= dojo.hitch(this, function(error, resultParameters) {
			this._onRemainingWorkItemsSaveFailed(workingCopy, error);
		});
		workingCopy.storeWorkItem(saveArgs);
	},

	_onRemainingWorkItemSaved: function(workingCopy, attributes) {
		var info= {};
		info.itemId= workingCopy.getItemId();
		info.workItemId= workingCopy.getId();
		info.description= workingCopy.getSummaryLabel();
		this._createdItems.push(info);
		workingCopy.decrementUseCount(true);
		this._currentRequirementIndex++;
		this._updateProgressLabel();
		this._createRemainingWorkItems(attributes);
	},

	_onRemainingWorkItemsSaveFailed: function(workingCopy, error) {
		workingCopy.decrementUseCount(true);
		this._handleError(dojo.string.substitute(this._messages.ITEMS_FROM_REQ_ERROR_CREATING, [error]), error);
	},

	_onOkEnablementChange: function(isDirty) {
		this._updateButtons(isDirty);
	},

	isApplyAllEnabled: function() {
		return this._currentRequirementIndex + 1 < this._requirementInfos.length;
	},

	_updateButtons: function(canCreate) {
		if (this._applyAllButton != null && this._nextButton != null){
			var isApplyAllEnabled= this.isApplyAllEnabled();
			this._applyAllButton.disabled= canCreate && isApplyAllEnabled ? "" : "disabled";//$NON-NLS-1$//$NON-NLS-2$
			this._nextButton.disabled= canCreate ? "" : "disabled";//$NON-NLS-1$//$NON-NLS-2$
			if (!isApplyAllEnabled){
				this._nextButton.replaceChild(window.document.createTextNode(this._messages.ITEMS_FROM_REQ_FINISH), this._nextButton.firstChild);
			};
		};
	},

	_updateProgressLabel: function() {
		var textNode= window.document.createTextNode(dojo.string.substitute(this._messages.ITEMS_FROM_REQ_PROGRESS, [this._currentRequirementIndex.toString(), this._requirementInfos.length.toString()]));
		this._progressLabel.replaceChild(textNode, this._progressLabel.firstChild);
	},

	_onDialogClosed: function() {
		this._dialog= null;
		this.destroy(false);
		if (this._onClose != null){
			this._onClose(this._createdItems);
			this._onClose= null;
		};
	},

	_handleError: function(string, error) {
		console.log(string + error);
	},

	destroy: function(preserveDom) {
		if (this._dialog != null){
			this._dialog.destroy(preserveDom);
			this._dialog= null;
		};
		if (this._currentInlineWorkItemContent != null){
			this._currentInlineWorkItemContent.destroy(false);
			this._currentInlineWorkItemContent= null;
		};
		this.inherited("destroy", arguments, [preserveDom]);//$NON-NLS-1$
	},

	$capabilities: {
		'com.ibm.jdojo.dijit._Templated': true//$NON-NLS-1$
	}
});

})();
