/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.users.AssignmentLabelProvider"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ImageClient") //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.viewers.ActionColumnLabelProvider"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.users.dialogs.AssingmentEditDialog"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var ImageClient				= com.ibm.team.apt.web.client.internal.ImageClient;
var AssingmentEditDialog		= com.ibm.team.apt.web.ui.internal.users.dialogs.AssingmentEditDialog;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	
dojo.declare("com.ibm.team.apt.web.ui.internal.users.AssignmentLabelProvider", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.viewers.ActionColumnLabelProvider], {
	
	constructor: function() {
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	
	getLabel: function(element, index) {
		if (index == 0) {
			if (element.isArchived)
				return bind(MSGS.USER_EDITOR_ASSIGNMENT_ARCHIVED, [element.label])
			
			return element.label;
		} else if (index == 1) {
			if (!element.hasChildren || element.children.length > 1) {
				if (element.percentage == 0) {
					return MSGS.USER_EDITOR_ASSIGNMENT_PERCENT_NONE;
				} else {
					return bind(MSGS.USER_EDITOR_ASSIGNMENT_PERCENT, [element.percentage]);
				}
			}
			
			return ""; //$NON-NLS-1$
		}
	},
	
	getIcon: function(element, index) {
		if (index == 0) {
			if (element.isDevelopmentLine) {
				if (element.isArchived) {
					return dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/images/develop_line_arch_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				} else {
					return dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/images/develop_line_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				}
			} else if (element.isTeamArea) {
				return dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/images/teamarea_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			} else if (element.isProjectArea) {
				return dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/images/projectarea_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
	},
	
	destroy: function() {
		this.inherited(arguments);
	},
	
	// ---- SPI ------------------------------------------------------------------------------------------------------------
	
	_getActionColumnIndex: function() {
		return 2;
	},
	
	_createActions: function(element) {
		var result= new Array();
		if (element.hasChildren)
			return result;
		
		result.push(this.__createEditAction(element));
		return result;
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------
	
	__createEditAction: function(element) {
		return this._createAction(
				MSGS.USER_EDITOR_ASSIGNMENT_ACTIONS_EDIT_LABEL, 
				ImageClient.getImageUrl(dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/images/edit.gif")), //$NON-NLS-1$ //$NON-NLS-2$
				dojo.hitch(this, function() {
					this.__doEdit(element);
				})
		);
	},
	
	
	__doEdit: function(element) {
		var _self= this;
		new AssingmentEditDialog({
			assignment: element,
			onOk: function() {
				element.markChanged();
			},
			onCancel: function() {
			}
		});
	},

	__sentinel: null // terminates this class definition
});

})();
