/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.ModifyWorkItemMenuAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.MenuAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.ModifyPlannedForAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.ModifyOwnerAction"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$=
dojo.require("dojo.string"); //$NON-NLS-1$

(function() {
	
var Action							= com.ibm.team.apt.web.ui.internal.view.plan.actions.Action;
var ModifyPlannedForAction			= com.ibm.team.apt.web.ui.internal.view.plan.actions.ModifyPlannedForAction;
var ModifyOwnerAction				= com.ibm.team.apt.web.ui.internal.view.plan.actions.ModifyOwnerAction;


var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var bind= dojo.string.substitute;

var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/menu.png"); //$NON-NLS-1$ //$NON-NLS-2$
	
function getEntriesToModify(viewModel, viewerItem) {
	var selection= viewModel.getSelectedEntries();
	var targetEntry= viewerItem.getViewEntry();
	if (!dojo.some(selection, function(selected) { return selected === targetEntry; } )) {
		selection.push(targetEntry);
	}
	return selection;
}

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.ModifyWorkItemMenuAction", //$NON-NLS-1$
		[com.ibm.team.apt.web.ui.internal.view.plan.actions.MenuAction], {
	
	constructor: function(viewModel, itemMovePolicy, errorReporter, viewerItem) {
		this._viewModel= viewModel;
		this._itemMovePolicy= itemMovePolicy;
		this._errorReporter= errorReporter;
		this._viewerItem= viewerItem;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getName: function() {
		var selectedCount= getEntriesToModify(this._viewModel, this._viewerItem).length;
		var pattern= selectedCount <= 1 ? MSGS.action_menuTooltip: MSGS.action_menuTooltipMultiple;
		return bind(pattern, [selectedCount]);
	},
	
	getStyle: function() {
		return this.inherited("getStyle", arguments, arguments) |  Action.STYLE_SHOW_AS_SELECTED; //$NON-NLS-1$
	},
	
	getId: function() {
		return "modify"; //$NON-NLS-1$
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	createActions: function() {
		var result= [];
		result.push(new ModifyPlannedForAction(this._viewModel, this._itemMovePolicy, this._errorReporter, this._viewerItem));
		result.push(new ModifyOwnerAction(this._viewModel, this._itemMovePolicy, this._errorReporter, this._viewerItem));
		return result;
	},
	
	canHandle: function() {
		var selectedEntries= getEntriesToModify(this._viewModel, this._viewerItem);
		return selectedEntries.length > 0 && dojo.every(selectedEntries, function(entry) {
			return entry.getElement() instanceof com.ibm.team.apt.client.PlanItem;
		}, this);
	},

	__sentinel: null // terminates this class definition
});

})();
