/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.SelectBetweenAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {
	
var Assert							= com.ibm.team.apt.web.ui.internal.common.Assert;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.SelectBetweenAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {
	
	_viewModel: null,
	
	constructor: function(viewModel) {
		this._viewModel= viewModel;
	},

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "select.between"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_SELECT_BETWEEN;
	},
	
	canHandle: function(entry, selection) {
		return (selection.length == 1 && entry != selection[0]) || selection.length == 2;
	},
	
	handle: function(entry, selection) {
		var start= selection[0];
		var end;
		if (selection.length == 2) {
			end= selection[1];
		} else {
			end= entry;
		}
		
		var newSelection= [];
		newSelection.push(start);
		
		this._viewModel.readModel(function(readAccessor) {
			var navigator= readAccessor.getEntryNavigator(true);
			if (!this._selectBetween(start, end, navigator, newSelection)) {
				newSelection= [];
				this._selectBetween(end, start, navigator, newSelection);
			}
		}, this);
		
		this._viewModel.setSelectedEntries(newSelection);
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------
	
	_selectBetween: function(start, end, navigator, result) {
		var current= start;
		while (current != null && !this._walk(current, end, navigator, result)) {
			var successor= navigator.successorEntry(current);
			if (successor == null) {
				current= navigator.parentEntry(current);
				if (current != null) {
					current= navigator.successorEntry(current);
				}
			} else {
				current= successor;
			}
		}
		
		return current != null;
	},
	
	_walk: function(entry, terminator, navigator, result) {
		result.push(entry);
		
		if (entry == terminator)
			return true;
		
		var children= navigator.childEntries(entry);
		for ( var i = 0; i < children.length; i++) {
			var child= children[i];
			if (this._walk(child, terminator, navigator, result))
				return true;
		}
		
		return false;
	},

	__sentinel: null // terminates this class definition
});

})();
