/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.TogglePlanFilterAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var Action= com.ibm.team.apt.web.ui.internal.view.plan.actions.Action;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.TogglePlanFilterAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {

	_tabPlannedItems: null,
	_filter: null,
		
	constructor: function(tabPlannedItems, filter) {
		this._tabPlannedItems= tabPlannedItems;
		this._filter= filter;
	},
	
	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "plan.toggleFilter"; //$NON-NLS-1$
	},
	
	getName: function() {
		return this._filter.name;
	},
	
	getStyle: function() {
		return Action.STYLE_FLAT | Action.STYLE_TOGGLE;
	},
	
	getIconUrl: function() {
		return null;
	},
		
	isChecked: function() {
		return this.__index() != -1;
	},
		
	canHandle: function() {
		return true;
	},
	
	handle: function(evt) {
		var index= this.__index();
		var planMode= this._tabPlannedItems.getPlanMode();
		if(index == -1) {
			planMode.filters.push(this._filter);
		} else {
			planMode.filters.splice(index, 1);
		}
		this._tabPlannedItems._applyOptions(planMode);		
	},
	
	__index: function() {
		var allIds= dojo.map(this._tabPlannedItems.getPlanMode().filters, function(filter) { return filter.id; });
		return dojo.indexOf(allIds, this._filter.id);
	},
	
	__sentinel: null // terminates this class definition
});

})();
