/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.InputDialog"); //$NON-NLS-1$

dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.InputDialog", null, { //$NON-NLS-1$
	
	constructor: function(params){
		var widgetParams = { primaryTitle: params.message, width: "35em"  }; //$NON-NLS-1$

		var onCancel= dojo.hitch(this,function(attributes) {
			this.floatingPane.close();
		});
		
		this.contentWidget= new com.ibm.team.apt.web.ui.internal.view.plan.dialogs.InputDialogContent({
			onOk: params.onOk, 
			onCancel: onCancel, 
			fnValidate: params.fnValidate,
			description: params.description
		});
		widgetParams.contentNode = this.contentWidget.domNode;
		this.floatingPane = new jazz.ui.Dialog(widgetParams); 
		this.contentWidget.init();
	}
	
});

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.InputDialogContent", //$NON-NLS-1$
	[dijit._Widget, dijit._Templated], {
	
	__firstValidation: null,
	
	templateString: '<div style="padding: 1em 1em 1em 1em;">' + //$NON-NLS-1$
						'<span dojoAttachPoint="_contentNode" style="padding: 0.3em;"></span>' + //$NON-NLS-1$
						'<input dojoAttachPoint="_inputNode" style="width: 30em; height: 1.3em; background-color: #FFFFFF; border: 1px solid #CCCCCC;"></input>' + //$NON-NLS-1$
						'<div style="padding: 1em 0em; float: right;">' + //$NON-NLS-1$
							'<button dojoAttachPoint="_okCmd">OK</button>' + //$NON-NLS-1$
							'<button dojoAttachPoint="_cancelCmd">Cancel</button>' + //$NON-NLS-1$
						'</div>' + //$NON-NLS-1$
						'<div style="padding: 1em 0em; width: 20em; color: red;" dojoAttachPoint="_validateNode"></div>' + //$NON-NLS-1$
					' </div>', //$NON-NLS-1$
	
	constructor: function(params){
		this._onOk= params.onOk;
		this._onCancel= params.onCancel;
		this._fnValidate= params.fnValidate;
		this._description= params.description;
		
		this.__firstValidation= true;
	},
	
	postCreate: function() {
		this.connect(this._okCmd, "onclick", dojo.hitch(this, function() { this._onCancel(); /*close*/ this._onOk(this._inputNode.value); })); //$NON-NLS-1$
		this.connect(this._inputNode, "onkeydown", dojo.hitch(this, function(e) { //$NON-NLS-1$
			if(this._okCmd.disabled)
				return;
			if(e.keyCode != 13)
				return;
			dojo.stopEvent(e);
			this._onCancel();
			this._onOk(this._inputNode.value);
		})); 
		this.connect(this._cancelCmd, "onclick", this._onCancel); //$NON-NLS-1$
		
		if(dojo.isFunction(this._fnValidate)){
			var validation= dojo.hitch(this, function(){
				var msg= this._fnValidate(this._inputNode.value);
				this._okCmd.disabled= Boolean(msg);
				if(!this.__firstValidation){
					this._validateNode.innerHTML= msg === null ? "" : String(msg); //$NON-NLS-1$
				}
				this.__firstValidation= false;
			});
			this.connect(this._inputNode, "onkeyup", validation); //$NON-NLS-1$
			validation();
		}
		
		this._contentNode.innerHTML= this._description;
	},
	
	init: function() {
	}
	
});

})();
