/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.view.common.Section");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.ContentPane");

(function(){

var	CLS_COLLAPSED = "toggleCollapsed";
var	CLS_SECTION = "toggleNode";

dojo.declare(
	"com.ibm.rational.cm.web.ui.view.common.Section",
	[dijit._Widget, dijit._Templated],
{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.rational.cm.web", "ui/view/common/templates/Section.html"),
	
	title: '',
	titleNode: null,
	content: '',
	contentNode: null,
	collapsed: false,
	
	postCreate: function(){
		this.inherited(arguments);

		// setup title node
		if(!this.titleNode){
			var titleNode = this.titleNode = dojo.doc.createElement("SPAN");
			dojo.attr(titleNode, {
				onkeydown: dojo.hitch(this, "_handleKeyDown"),
				className: "sectionTitle",
				tabindex: 0,
				innerHTML: this.title
			});
			dojo.place(titleNode, this.toggleNode, "after")
		}
		
		// setup content node
		if(!this.contentNode){
			var pane = new dijit.layout.ContentPane();
			var contentNode = this.contentNode = pane.domNode;
			dojo.addClass(contentNode, "sectionContent");
			this.domNode.appendChild(contentNode);
		}
		this.setContent(this.content);

		this.doCollapse(this.collapsed);
	},
	
	setContent: function(content){
		this.content = content;
		this.contentNode.innerHTML = content;
	},
	
	toggleSection: function(e){
		this.doCollapse(!this.collapsed);
	},
	
	isCollapsed: function(){
		return this.collapsed;
	},
	
	doCollapse: function(/* boolean */ doCollapse){
		this.contentNode.style.display = (doCollapse) ? "none" : "";
		this.collapsed = doCollapse;
		dojo.toggleClass(this.toggleNode, CLS_COLLAPSED, doCollapse);
	},
	
	_handleKeyDown: function(e){
		if(e.keyCode == dojo.keys.LEFT_ARROW){
			this.doCollapse(true);
			dojo.stopEvent(e);
		}else if(e.keyCode == dojo.keys.RIGHT_ARROW){
			this.doCollapse(false);
			dojo.stopEvent(e);
		}
	},
	
	getTitle: function(){
		return this.title;
	},
	
	setTitle: function(title){
		this.title = title;
		this.titleNode.innerHTML = title;
	}
});

})();