/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.dialog.CALMBackLinkProblemDialogLauncher"); 
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.RadioGroupPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.IconMessageWidget");
dojo.require("com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog");
dojo.require("com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy"); 
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "ModuleMessages");

(function() {


dojo.declare("com.ibm.team.workitem.web.ui2.internal.dialog.CALMBackLinkProblemDialogLauncher", null, {
	openCALMBackLinkProblemDialog: function(parms) {
    if(!this.CALMMessages) this.CALMmessages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "ModuleMessages");
    	
	// messageDTOs, 
	var messageDTOs = parms.error.infos;
   
	var presentations = [
		{
			widget: "com.ibm.team.workitem.web.ui.internal.view.layout.IconMessageWidget",
			message: this.CALMmessages.CALMBackLinkProblemDialog_DIALOG_DESCRIPTION,
			severity: parms.error.severity, // info
			iconSize: 1 // big	
		},
		{
			widget: "com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget",
			attributeId: "messageDTOs",
			possibleValues: messageDTOs,
			isErrorList: true,
			messageSelector: "summary",
			detailsSelector: "description",
			size: 4
		},
		{
			widget: "com.ibm.team.workitem.web.ui.internal.view.editor.parts.RadioGroupPart",
			attributeId: "saveOption",
			attributeValue: "1",
			possibleValues: [ 
				{
					label: this.CALMmessages.CALMBackLinkProblemDialog_RETRY_LABEL,
					id: "1"
				},
				{
					label: this.CALMmessages.CALMBackLinkProblemDialog_REVERT_LABEL,
					id: "2"
				},				
				{
					label: this.CALMmessages.CALMBackLinkProblemDialog_SKIP_BACK_LINKS_LABEL,
					id: "3"
				}
				]
					
		},
		{
			widget: "com.ibm.team.workitem.web.ui.internal.view.layout.IconMessageWidget",
			message: this.CALMmessages.CALMBackLinkProblemDialog_SKIP_BACK_LINKS_INFO,
			severity: parms.error.severity, 
			iconSize: 0 // small	
		}
		
	];
	
	var policyRequest = {
		attributes: {
			messageDTOs: messageDTOs,
			saveOption: {id: "1"}
		}
	}
	var policyRequestProxy =  new com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy({ object: policyRequest}); 
	
	var dialogArgs = {
		dialogTitle: this.CALMmessages.CALMBackLinkProblemDialog_BUTTON_SAVE,
		secondaryTitle: "",
		height: "22.5em",		
		workingCopy: policyRequestProxy,
		OkLabel: this.CALMmessages.CALMBackLinkProblemDialog_BUTTON_SAVE,
		onOk: function(args) {
				parms.onOk(args);
			},
		onCancel: function(args) {
			parms.onCancel(args);
		},
		presentations: presentations
	}
	new com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog(dialogArgs);
}
}
);

})();
