/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.PlanAttributeRegistry"); //$NON-NLS-1$

(function() {
	
dojo.declare("com.ibm.team.apt.client.PlanAttributeRegistry", null, { //$NON-NLS-1$
	
	__attributes: null,
	
	constructor: function() {
		this.__attributes= {};
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	registerAttribute: function(attribute) {
		this.__attributes[attribute.getId()]= attribute;
	},
	
	getAttribute: function(attributeIdentifier) {
		return this.__attributes[attributeIdentifier.getId()] || null;
	},

	getAllAttributes: function() {
		var result= [];
		for (var id in this.__attributes) {
			result.push(this.__attributes[id]);
		}
		
		return result;
	},

	getAttributes: function(attributeType) {
		var result= [];
		
		for (var id in this.__attributes) {
			if (this.__attributes[id] instanceof attributeType) {
				result.push(this.__attributes[id]);
			}
		}
		
		return result;
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
